import java.io.*;
import hpkg.fund.pnm.*;

public class prog2A
{
   public static void main(String[] args)
   {
      try
      {
         // コマンドライン引数を解析する．
         if(args.length != 2)
         {
            System.err.println("java prog2A 入力画像.ppm 出力画像.ppm");
            System.exit(0);
         }
	 
         HPnm inImg = new HPnm();
         inImg.readVoxels(args[0]);

         int ysize = inImg.ysize();
         int xsize = inImg.xsize();
	 
         HPnm outImg = new HPnm(xsize, ysize, 32); // 画素サイズは 32 Bit Per Pixel.

         for(int y=0; y<ysize; y++) for(int x=0; x<xsize; x++)
         {
            int value = inImg.getUnsignedValue(x, y);
            int red   =  value        & 0xff; // 赤値の取得．
            int green = (value >>  8) & 0xff; // 緑値の取得．
            int blue  = (value >> 16) & 0xff; // 青値の取得．

            int red1   = 255 - red;   // 赤値を反転．
            int green1 = 255 - green; // 緑値を反転．
            int blue1  = 255 - blue;  // 青値を反転．

            // 色反転した値をマージする．
            int value1 = (0xff & red1) + (0xff00 & (green1 << 8)) + (0xff0000 & (blue1 << 16));

            outImg.setValue(x, y, value1);
         }

         outImg.writeVoxels(args[1]);
      }
      catch(Exception e)
      {
         e.printStackTrace();
      }
   }
}
