/* PGM($B%P%$%J%j(B)$B2hA|$K(B Quoit $B%U%#%k%?$r;\$7(B,$B7k2L2hA|(B(PGM$B7A<0(B)$B$r=PNO$9$k(B
   $B%W%m%0%i%`(B. */
import java.io.*;
import hpkg.fund.voxels.*;
import hpkg.fund.pnm.*;

public class prog4A
{
   static final int R1 = 14;	 /* Disk$B307B(B */
   static final int R2 = 13;	 /* Ring$BFb7B(B($BI,$:(B R2<R3 $B$K$9$k$3$H(B) */
   static final int R3 = 14;	 /* Ring$B307B(B($BI,$:(B R2<R3 $B$K$9$k$3$H(B) */
   static final int SMOOTHF_SIZE = 5;	 /* filter size for smoothing */

   public static void main(String[] args)
   {
      try
      {
         if(args.length != 2)
         {
            System.err.println("java prog4A inImg.pgm outImg.pgm");
            System.exit(0);
         }

         HPnm inImg = new HPnm();
         inImg.readVoxels(args[0]); // $B2hA|F~NO!%(B
	 
         HPnm inImgSM = smooth(inImg, SMOOTHF_SIZE); // $BJ?3j2=$9$k!%(B
	 
         HPnm diskFilter = createFilter(R1,  0); // $B%G%#%9%/%U%#%k%?$r:n@.$9$k!%(B
         HPnm ringFilter = createFilter(R3, R2); // $B%j%s%0%U%#%k%?$r:n@.$9$k!%(B

         // $BF~NO2hA|$H%G%#%9%/%U%#%k%?(B,$B%j%s%0%U%#%k$H$N(B Dilation $B2hA|$r5a$a$k!%(B
         HPnm diskImg = dilation(inImgSM, diskFilter);
         HPnm ringImg = dilation(inImgSM, ringFilter);

         HPnm outImg = new HPnm(inImg.xsize(), inImg.ysize(), 8); // $B=PNOMQ$N2hA|!%(B
   
         // $BN>2hA|$N:9J,$r5a$a$k!%(B
         for(int y=0; y<diskImg.ysize(); y++) for(int x=0; x<diskImg.xsize(); x++)
         {
            int value = diskImg.getValue(x, y) - ringImg.getValue(x, y);
            outImg.setValue(x, y, value);
         }
         outImg.writeVoxels(args[1]); // $B7k2L2hA|$N=PNO!%(B
      }
      catch(Exception ex)
      {
         ex.printStackTrace();
      }
   }

   /** $B2hA|(B img $B$K(B fsize$B!_(Bfsize $B$NJ?3j2=%U%#%k%?$r;\$7!$7k2L2hA|$rJV$9!%(B*/
   private static HPnm smooth(HPnm img, int fsize)
      throws HVoxelMakingFailureException, HUnknownDepthSpecifiedException
   {
      HPnm smImg = new HPnm(img.xsize(), img.ysize(), 32); // $B7k2L2hA|!%(B
      for(int y=fsize/2; y<img.ysize()-fsize/2; y++) for(int x=fsize/2; x<img.xsize()-fsize/2; x++)
      {
         // $B2hAG?t$H2hAGCMOB$r7W;;$9$k!%(B
         int xd, yd, num = 0;
         double sum = 0;
         for(yd=-fsize/2; yd<=fsize/2; yd++) for(xd=-fsize/2; xd<=fsize/2; xd++)
         {
            sum += img.getUnsignedValue(x+xd, y+yd);
            num++;
         }

         // $BJ?6QCM$r(B (x,y) $B$NCM$K$9$k!%(B
         smImg.setValue(x, y, (int)Math.rint(sum/num));
      }
      return smImg;
   }

   /** $B307B(B radiusOutside, $BFb7B(B radiusInside $B$N(B($B%j%s%0(B)$B%U%#%k%?$r:n@.$9(B
       $B$k!%$?$@$7%U%#%k%?$G$O2hA|Cf1{$,:BI886E@$G$"$k$H2>Dj$9$k!%(B*/
   private static HPnm createFilter(int radiusOutside, int radiusInside)
      throws HVoxelMakingFailureException, HUnknownDepthSpecifiedException
   {
      HPnm filter = new HPnm(radiusOutside*2+1, radiusOutside*2+1, 32);
      for(int y=0; y<filter.ysize(); y++) for(int x=0; x<filter.xsize(); x++)
      {
         int u = x - filter.xsize()/2; // $B2hA|Cf1{$,:BI886E@$K$J$k$h$&$K:BI8JQ49$9$k!%(B
         int v = y - filter.ysize()/2;
         double r = Math.sqrt(u*u + v*v);
	 
         // $B86E@$H$N5wN%$K$h$C$F!$%<%m$+Ii$NL58BBg$NCM$r@_Dj$9$k!%(B
         if((double)radiusInside <= r && r <= (double)radiusOutside)
         {
            filter.setValue(x, y, 0);
         }
         else
         {
            filter.setValue(x, y, Integer.MIN_VALUE);
         }
      }
      return filter;
   }
   
   /** f $B$H(B g $B$N%b%k%U%)%m%8(B Dilation $B1i;;$r9T$$!$7k2L$N2hA|$rJV$9!%K\Mh$O9=B$MWAG(B 
       g $B$K$OBP>N2hA|$rF~NO$9$kI,MW$,$"$k$,!$N>%U%#%k%?$H$b86E@BP>N$J$N$G>JN,$9$k!%(B*/
   private static HPnm dilation(HPnm f, HPnm g)
      throws HVoxelMakingFailureException, HUnknownDepthSpecifiedException
   {
      HPnm diaOut = new HPnm(f.xsize(), f.ysize(), 32);

      // $B3F(B (x,y) $B$K$D$$$F(B f $B$H(B g $B$NOB$N:GBgCM$r$b$H$a$F!$(BdiaOut $B$K@_Dj$9$k!%(B
      for(int y=0; y<diaOut.ysize(); y++) for(int x=0; x<diaOut.xsize(); x++)
      {
         int maxValue = Integer.MIN_VALUE;
         for(int v=-g.ysize()/2; v<=g.ysize()/2; v++) for(int u=-g.xsize()/2; u<=g.xsize()/2; u++)
         {
            int xu = x + u;
            int yv = y + v;

            // (x+u,y+v)$B":(BF$B$N%A%'%C%/(B ( (u,v)$B":(BG$B$OL@$i$+$K@.N)$9$k(B)$B!%(B
            if(0<=xu && xu<f.xsize() && 0<=yv && yv<f.ysize())
            {
               int value = f.getValue(xu, yv) + g.getValue(u+g.xsize()/2, v+g.ysize()/2);
               maxValue = Math.max(maxValue, value);
            }
         }
         diaOut.setValue(x, y, maxValue);
      }
      return diaOut;
   }
}

// end of file
